# std::__debug::set< _Key, _Compare, _Allocator > Class Template Reference

Inheritance diagram for std::__debug::set< _Key, _Compare, _Allocator >:

List of all members.

## Detailed Description

### template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>
class std::__debug::set< _Key, _Compare, _Allocator >

Definition at line 48 of file set.h.

## Public Types

- typedef _Allocator allocator_type
- typedef __gnu_debug::_Safe_iterator<
  typename _Base::const_iterator,
  set > const_iterator
- typedef _Base::const_pointer const_pointer
- typedef _Base::const_reference const_reference
- typedef std::reverse_iterator<
  const_iterator > const_reverse_iterator
- typedef _Base::difference_type difference_type
- typedef __gnu_debug::_Safe_iterator<
  typename _Base::iterator,
  set > iterator
- typedef _Compare key_compare
- typedef _Key key_type
- typedef _Base::pointer pointer
- typedef _Base::reference reference
- typedef std::reverse_iterator<
  iterator > reverse_iterator
- typedef _Base::size_type size_type
- typedef _Compare value_compare
- typedef _Key value_type

## Public Member Functions

- const _Base & _M_base () const
- _Base & _M_base ()
- void _M_invalidate_all () const
- template<typename _Predicate> void _M_invalidate_if (_Predicate __pred)
- template<typename _Iterator> void _M_transfer_iter (const _Safe_iterator< _Iterator, _Sequence > &__x)
- const_iterator begin () const
- iterator begin ()
- void clear ()
- size_type count (const key_type &__x) const
- bool empty () const
- const_iterator end () const
- iterator end ()
- std::pair< const_iterator,
  const_iterator > equal_range (const key_type &__x) const
- std::pair< iterator, iterator > equal_range (const key_type &__x)
- void erase (iterator __first, iterator __last)
- void erase (iterator __position)
- void erase (iterator __first, iterator __last)
- size_type erase (const key_type &__x)
- void erase (iterator __position)
- const_iterator find (const key_type &__x) const
- iterator find (const key_type &__x)
- allocator_type get_allocator () const
- iterator insert (iterator __position, const value_type &__x)
- template<typename _InputIterator> void insert (_InputIterator __first, _InputIterator __last)
- iterator insert (iterator __position, const value_type &__x)
- std::pair< iterator, bool > insert (const value_type &__x)
- key_compare key_comp () const
- const_iterator lower_bound (const key_type &__x) const
- iterator lower_bound (const key_type &__x)
- size_type max_size () const
- set< _Key, _Compare, _Allocator > & operator= (const set< _Key, _Compare, _Allocator > &__x)
- const_reverse_iterator rbegin () const
- reverse_iterator rbegin ()
- const_reverse_iterator rend () const
- reverse_iterator rend ()
- set (const _Base &__x)
- set (const set< _Key, _Compare, _Allocator > &__x)
- template<typename _InputIterator> set (_InputIterator __first, _InputIterator __last, const _Compare &__comp=_Compare(), const _Allocator &__a=_Allocator())
- set (const _Compare &__comp=_Compare(), const _Allocator &__a=_Allocator())
- size_type size () const
- void swap (set< _Key, _Compare, _Allocator > &__x)
- const_iterator upper_bound (const key_type &__x) const
- iterator upper_bound (const key_type &__x)
- value_compare value_comp () const
- ~set ()

## Public Attributes

- _Safe_iterator_base * _M_const_iterators
- _Safe_iterator_base * _M_iterators
- unsigned int _M_version

## Protected Member Functions

- void _M_detach_all ()
- void _M_detach_singular ()
- __gnu_cxx::__mutex & _M_get_mutex ()
- void _M_revalidate_singular ()
- void _M_swap (_Safe_sequence_base &__x)

## Friends

- bool operator< (const set< _K1, _C1, _A1 > &, const set< _K1, _C1, _A1 > &)
- bool operator== (const set< _K1, _C1, _A1 > &, const set< _K1, _C1, _A1 > &)

## Member Typedef Documentation

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

typedef _Key std::__debug::set< _Key, _Compare, _Allocator >::key_type

Public typedefs.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 57 of file set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

typedef _Base::pointer std::__debug::set< _Key, _Compare, _Allocator >::pointer

Iterator-related typedefs.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 72 of file set.h.

## Constructor & Destructor Documentation

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

std::__debug::set< _Key, _Compare, _Allocator >::set | ( | const _Compare & | __comp = `_Compare()`,
|  | const _Allocator & | __a = `_Allocator()` |
| ) |  |  | `[inline, explicit]`

Default constructor creates no elements.

Parameters:

  | comp | Comparator to use.
  | a | Allocator to use.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 78 of file set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>
template<typename _InputIterator>

std::__debug::set< _Key, _Compare, _Allocator >::set | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const _Compare & | __comp = `_Compare()`,
|  | const _Allocator & | __a = `_Allocator()` |
| ) |  |  | `[inline]`

Builds a set from a range.

Parameters:

  | first | An input iterator.
  | last | An input iterator.
  | comp | A comparison functor.
  | a | An allocator object.

Create a set consisting of copies of the elements from [first,last). This is linear in N if the range is already sorted, and NlogN otherwise (where N is distance(first,last)).

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 83 of file set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

std::__debug::set< _Key, _Compare, _Allocator >::set | ( | const set< _Key, _Compare, _Allocator > & | __x | ) | `[inline]`

Set copy constructor.

Parameters:

  | x | A set of identical element and allocator types.

The newly-created set uses a copy of the allocation object used by x.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 89 of file set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

std::__debug::set< _Key, _Compare, _Allocator >::set | ( | const _Base & | __x | ) | `[inline]`

Set copy constructor.

Parameters:

  | x | A set of identical element and allocator types.

The newly-created set uses a copy of the allocation object used by x.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 92 of file set.h.

## Member Function Documentation

void __gnu_debug::_Safe_sequence_base::_M_detach_all | ( |  | ) | `[protected, inherited]`

Detach all iterators, leaving them singular.

Referenced by __gnu_debug::_Safe_sequence_base::~_Safe_sequence_base().

void __gnu_debug::_Safe_sequence_base::_M_detach_singular | ( |  | ) | `[protected, inherited]`

Detach all singular iterators.

Postcondition:
  for all iterators i attached to this sequence, i->_M_version == _M_version.

Referenced by std::__debug::deque< _Tp, _Allocator >::erase(), and std::__debug::list< _Tp, _Allocator >::resize().

__gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex | ( |  | ) | `[protected, inherited]`

For use in _Safe_sequence.

void __gnu_debug::_Safe_sequence_base::_M_invalidate_all | ( |  | ) | const`[inline, inherited]`

Invalidates all iterators.

Definition at line 220 of file safe_base.h.

References __gnu_debug::_Safe_sequence_base::_M_version.

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::append(), std::__debug::vector< _Tp, _Allocator >::assign(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign(), std::__debug::deque< _Tp, _Allocator >::assign(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::c_str(), std::__debug::vector< _Tp, _Allocator >::clear(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::clear(), std::__debug::deque< _Tp, _Allocator >::clear(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::data(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::erase(), std::__debug::deque< _Tp, _Allocator >::erase(), __gnu_debug::getline(), std::__debug::vector< _Tp, _Allocator >::insert(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::insert(), std::__debug::deque< _Tp, _Allocator >::insert(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator+=(), std::__debug::vector< _Tp, _Allocator >::operator=(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator=(), std::__debug::deque< _Tp, _Allocator >::operator=(), __gnu_debug::operator>>(), std::__debug::vector< _Tp, _Allocator >::push_back(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::push_back(), std::__debug::deque< _Tp, _Allocator >::push_back(), std::__debug::deque< _Tp, _Allocator >::push_front(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace(), std::__debug::vector< _Tp, _Allocator >::reserve(), std::__debug::vector< _Tp, _Allocator >::resize(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::resize(), std::__debug::deque< _Tp, _Allocator >::resize(), and __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::swap().

template<typename _Sequence>
template<typename _Predicate>

void __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if | ( | _Predicate | __pred | ) | `[inherited]`

Invalidates all iterators `x` that reference this sequence, are not singular, and for which `pred(x)` returns `true`. The user of this routine should be careful not to make copies of the iterators passed to `pred`, as the copies may interfere with the invalidation.

Definition at line 126 of file safe_sequence.h.

References __gnu_debug::_Safe_sequence_base::_M_const_iterators, and __gnu_debug::_Safe_sequence_base::_M_iterators.

Referenced by std::__debug::vector< _Tp, _Allocator >::erase(), std::__debug::vector< _Tp, _Allocator >::insert(), std::__debug::vector< _Tp, _Allocator >::resize(), and std::__debug::deque< _Tp, _Allocator >::resize().

void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular | ( |  | ) | `[protected, inherited]`

Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reasion, such as an exception, need to become valid again).

Referenced by std::__debug::deque< _Tp, _Allocator >::erase(), and std::__debug::list< _Tp, _Allocator >::resize().

void __gnu_debug::_Safe_sequence_base::_M_swap | ( | _Safe_sequence_base & | __x | ) | `[protected, inherited]`

Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

Referenced by std::__debug::vector< _Tp, _Allocator >::swap(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::swap(), std::__debug::set< _Key, _Compare, _Allocator >::swap(), std::__debug::multiset< _Key, _Compare, _Allocator >::swap(), std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::swap(), std::__debug::map< _Key, _Tp, _Compare, _Allocator >::swap(), std::__debug::list< _Tp, _Allocator >::swap(), __gnu_cxx::__debug::hash_set< _Value, _HashFcn, _EqualKey, _Alloc >::swap(), __gnu_cxx::__debug::hash_multiset< _Value, _HashFcn, _EqualKey, _Alloc >::swap(), __gnu_cxx::__debug::hash_multimap< _Value, _Tp, _HashFcn, _EqualKey, _Alloc >::swap(), __gnu_cxx::__debug::hash_map< _Value, _Tp, _HashFcn, _EqualKey, _Alloc >::swap(), and std::__debug::deque< _Tp, _Allocator >::swap().

template<typename _Sequence>
template<typename _Iterator>

void __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter | ( | const _Safe_iterator< _Iterator, _Sequence > & | __x | ) | `[inherited]`

Transfers all iterators that reference this memory location to this sequence from whatever sequence they are attached to.

Definition at line 159 of file safe_sequence.h.

References __gnu_debug::_Safe_sequence_base::_M_const_iterators, __gnu_debug::_Safe_sequence_base::_M_iterators, __gnu_debug::_Safe_iterator_base::_M_sequence, and __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::base().

Referenced by std::__debug::list< _Tp, _Allocator >::splice().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

const_iterator std::__debug::set< _Key, _Compare, _Allocator >::begin | ( |  | ) | const`[inline]`

Returns a read/write iterator that points to the first element in the set. Iteration is done in ascending order according to the keys.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 112 of file set.h.

References std::set< _Key, _Compare, _Allocator >::begin().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

void std::__debug::set< _Key, _Compare, _Allocator >::clear | ( |  | ) | `[inline]`

Erases all elements in a set. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 210 of file set.h.

References std::__debug::set< _Key, _Compare, _Allocator >::begin(), std::__debug::set< _Key, _Compare, _Allocator >::end(), and std::__debug::set< _Key, _Compare, _Allocator >::erase().

size_type std::set< _Key , _Compare , _Allocator >::count | ( | const key_type & | __x | ) | const`[inline, inherited]`

Finds the number of elements.

Parameters:

  | x | Element to located.

Returns:
  Number of elements with specified key.

This function only makes sense for multisets; for set the result will either be 0 (not present) or 1 (present).

Definition at line 411 of file stl_set.h.

References std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::end(), and std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::find().

bool std::set< _Key , _Compare , _Allocator >::empty | ( |  | ) | const`[inline, inherited]`

Returns true if the set is empty.

Definition at line 261 of file stl_set.h.

References std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::empty().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

const_iterator std::__debug::set< _Key, _Compare, _Allocator >::end | ( |  | ) | const`[inline]`

Returns a read/write iterator that points one past the last element in the set. Iteration is done in ascending order according to the keys.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 120 of file set.h.

References std::set< _Key, _Compare, _Allocator >::end().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

std::pair<iterator,iterator> std::__debug::set< _Key, _Compare, _Allocator >::equal_range | ( | const key_type & | __x | ) | `[inline]`

Finds a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Pair of iterators that possibly points to the subsequence matching given key.

This function is equivalent to

        std::make_pair(c.lower_bound(val),
                       c.upper_bound(val))

(but is faster than making the calls separately).

This function probably only makes sense for multisets.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 251 of file set.h.

References std::equal_range(), std::pair< _T1, _T2 >::first, std::make_pair(), and std::pair< _T1, _T2 >::second.

void std::set< _Key , _Compare , _Allocator >::erase | ( | iterator | __first,
|  | iterator | __last |
| ) |  |  | `[inline, inherited]`

Erases a [first,last) range of elements from a set.

Parameters:

  | first | Iterator pointing to the start of the range to be erased.
  | last | Iterator pointing to the end of the range to be erased.

This function erases a sequence of elements from a set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 387 of file stl_set.h.

References std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::erase().

void std::set< _Key , _Compare , _Allocator >::erase | ( | iterator | __position | ) | `[inline, inherited]`

Erases an element from a set.

Parameters:

  | position | An iterator pointing to the element to be erased.

This function erases an element, pointed to by the given iterator, from a set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Definition at line 357 of file stl_set.h.

References std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::erase().

Referenced by std::__debug::set< _Key, _Compare, _Allocator >::erase().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

size_type std::__debug::set< _Key, _Compare, _Allocator >::erase | ( | const key_type & | __x | ) | `[inline]`

Erases elements according to the provided key.

Parameters:

  | x | Key of element to be erased.

Returns:
  The number of elements erased.

This function erases all the elements located by the given key from a set. Note that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibilty.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 178 of file set.h.

References __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::base(), std::__debug::set< _Key, _Compare, _Allocator >::end(), std::set< _Key, _Compare, _Allocator >::erase(), and std::__debug::set< _Key, _Compare, _Allocator >::find().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

iterator std::__debug::set< _Key, _Compare, _Allocator >::find | ( | const key_type & | __x | ) | `[inline]`

Tries to locate an element in a set.

Parameters:

  | x | Element to be located.

Returns:
  Iterator pointing to sought-after element, or end() if not found.

This function takes a key and tries to locate the element with which the key matches. If successful the function returns an iterator pointing to the sought after element. If unsuccessful it returns the past-the-end ( `end()` ) iterator.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 219 of file set.h.

References std::set< _Key, _Compare, _Allocator >::find().

Referenced by std::__debug::set< _Key, _Compare, _Allocator >::erase().

allocator_type std::set< _Key , _Compare , _Allocator >::get_allocator | ( |  | ) | const`[inline, inherited]`

Returns the allocator object with which the set was constructed.

Definition at line 222 of file stl_set.h.

References std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::get_allocator().

iterator std::set< _Key , _Compare , _Allocator >::insert | ( | iterator | __position,
|  | const value_type & | __x |
| ) |  |  | `[inline, inherited]`

Attempts to insert an element into the set.

Parameters:

  | position | An iterator that serves as a hint as to where the element should be inserted.
  | x | Element to be inserted.

Returns:
  An iterator that points to the element with key of x (may or may not be the element passed in).

This function is not concerned about whether the insertion took place, and thus does not return a boolean like the single-argument insert() does. Note that the first parameter is only a hint and can potentially improve the performance of the insertion process. A bad hint would cause no gains in efficiency.

See http://gcc.gnu.org/onlinedocs/libstdc++/23_containers/howto.html#4 for more on "hinting".

Insertion requires logarithmic time (if the hint is not taken).

Definition at line 331 of file stl_set.h.

References std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::_M_insert_unique().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>
template<typename _InputIterator>

void std::__debug::set< _Key, _Compare, _Allocator >::insert | ( | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

A template function that attemps to insert a range of elements.

Parameters:

  | first | Iterator pointing to the start of the range to be inserted.
  | last | Iterator pointing to the end of the range.

Complexity similar to that of the range constructor.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 163 of file set.h.

References __glibcxx_check_valid_range, and std::set< _Key, _Compare, _Allocator >::insert().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

std::pair<iterator, bool> std::__debug::set< _Key, _Compare, _Allocator >::insert | ( | const value_type & | __x | ) | `[inline]`

Attempts to insert an element into the set.

Parameters:

  | x | Element to be inserted.

Returns:
  A pair, of which the first element is an iterator that points to the possibly inserted element, and the second is a bool that is true if the element was actually inserted.

This function attempts to insert an element into the set. A set relies on unique keys and thus an element is only inserted if it is not already present in the set.

Insertion requires logarithmic time.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 146 of file set.h.

References std::pair< _T1, _T2 >::first, std::set< _Key, _Compare, _Allocator >::insert(), and std::pair< _T1, _T2 >::second.

key_compare std::set< _Key , _Compare , _Allocator >::key_comp | ( |  | ) | const`[inline, inherited]`

Returns the comparison object with which the set was constructed.

Definition at line 214 of file stl_set.h.

References std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::key_comp().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

iterator std::__debug::set< _Key, _Compare, _Allocator >::lower_bound | ( | const key_type & | __x | ) | `[inline]`

Finds the beginning of a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Iterator pointing to first element equal to or greater than key, or end().

This function returns the first element of a subsequence of elements that matches the given key. If unsuccessful it returns an iterator pointing to the first element that has a greater value than given key or end() if no such element exists.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 231 of file set.h.

References std::set< _Key, _Compare, _Allocator >::lower_bound().

size_type std::set< _Key , _Compare , _Allocator >::max_size | ( |  | ) | const`[inline, inherited]`

Returns the maximum size of the set.

Definition at line 271 of file stl_set.h.

References std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::max_size().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

set<_Key,_Compare,_Allocator>& std::__debug::set< _Key, _Compare, _Allocator >::operator= | ( | const set< _Key, _Compare, _Allocator > & | __x | ) | `[inline]`

Set assignment operator.

Parameters:

  | x | A set of identical element and allocator types.

All the elements of x are copied, but unlike the copy constructor, the allocator object is not copied.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 97 of file set.h.

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

const_reverse_iterator std::__debug::set< _Key, _Compare, _Allocator >::rbegin | ( |  | ) | const`[inline]`

Returns a read/write reverse iterator that points to the last element in the set. Iteration is done in descending order according to the keys.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 128 of file set.h.

References std::__debug::set< _Key, _Compare, _Allocator >::end().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

const_reverse_iterator std::__debug::set< _Key, _Compare, _Allocator >::rend | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to the last pair in the map. Iteration is done in descending order according to the keys.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 136 of file set.h.

References std::__debug::set< _Key, _Compare, _Allocator >::begin().

size_type std::set< _Key , _Compare , _Allocator >::size | ( |  | ) | const`[inline, inherited]`

Returns the size of the set.

Definition at line 266 of file stl_set.h.

References std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::size().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

void std::__debug::set< _Key, _Compare, _Allocator >::swap | ( | set< _Key, _Compare, _Allocator > & | __x | ) | `[inline]`

Swaps data with another set.

Parameters:

  | x | A set of the same element and allocator types.

This exchanges the elements between two sets in constant time. (It is only swapping a pointer, an integer, and an instance of the `Compare` type (which itself is often stateless and empty), so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(s1,s2) will feed to this function.

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 203 of file set.h.

References __gnu_debug::_Safe_sequence_base::_M_swap(), and std::tr1::swap().

Referenced by std::__debug::swap().

template<typename _Key, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<_Key>>

iterator std::__debug::set< _Key, _Compare, _Allocator >::upper_bound | ( | const key_type & | __x | ) | `[inline]`

Finds the end of a subsequence matching given key.

Parameters:

  | x | Key to be located.

Returns:
  Iterator pointing to the first element greater than key, or end().

Reimplemented from std::set< _Key, _Compare, _Allocator >.

Definition at line 241 of file set.h.

References std::set< _Key, _Compare, _Allocator >::upper_bound().

value_compare std::set< _Key , _Compare , _Allocator >::value_comp | ( |  | ) | const`[inline, inherited]`

Returns the comparison object with which the set was constructed.

Definition at line 218 of file stl_set.h.

References std::_Rb_tree< _Key, _Val, _KeyOfValue, _Compare, _Alloc >::key_comp().

## Member Data Documentation

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators`[inherited]`

The list of constant iterators that reference this container.

Definition at line 171 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators`[inherited]`

The list of mutable iterators that reference this container.

Definition at line 168 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

unsigned int __gnu_debug::_Safe_sequence_base::_M_version`[mutable, inherited]`

The container version number. This number may never be 0.

Definition at line 174 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence_base::_M_invalidate_all().

The documentation for this class was generated from the following file:

- set.h